#ifndef COMPONENT_H
#define COMPONENT_H

/* Krister Swenson                                           Spring 2003

A component has a list of boolean values for every cycle.  The true values
  indicate membership in this component.  A component can be good or bad.
*/


#include <iostream>
#include <cstdlib>
#include <cstdio>

class Component
  {
  friend std::ostream& operator<<(std::ostream& output, Component& c);

  public:
    Component(int spots);
    Component(const Component& c);
    ~Component();
    void operator=(const Component& c);

                     //Mark -cycle- as being part of this component.
    void makeMember(int cycle);
    void makeGood(); //Mark this component as being good.
    bool isGood();   //Returns true if this is a good component.

  private:
    void copy(const Component& c);

    bool good;       //TRUE if this is a good component.
    bool* members;   //members[i] is true if cycle i is a member.
    int cyclenum;    //The number of cycles to deal with.
  };

#endif
