/* Krister Swenson, Mark Marron                                   Spring 2003
A Pair has a left and right value.
*/

#ifndef PAIR_H
#define PAIR_H



#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <set>
#include <utility>
#include <ext/hash_set>
#include <ext/hash_map>

using namespace std;


class Pair
  {
  friend ostream& operator<<(ostream& output, const Pair& c);

  public:
    Pair();
    Pair(const pair<int,int> &p);
    Pair(int left, int right);
    Pair(const Pair& c);
    ~Pair();
    void operator=(const Pair& c);
    void operator=(const pair<int,int>& p);
    bool operator==(const Pair& c) const;
    bool operator==(const pair<int,int>& p) const;
    bool operator!=(const Pair& c) const;
    bool operator!=(const pair<int,int>& p) const;
    bool operator<(const Pair& p) const;
    bool operator>(const Pair& p) const;
      //Cast a Pair to and integer pair.
    operator pair<int,int>() const;


    bool overlaps(const Pair& p) const;
    int size() const;

    int getLeft() const;
    int getRight() const;
    void set(int l, int r);

  private:
    void copy(const Pair& c);

    int left;
    int right;
  };

  //Functions for keeping Sets of Pairs:
namespace __gnu_cxx
{
template<>
struct hash<const Pair>
  {
  hash<unsigned> hasher;
  size_t operator()(const Pair &p) const
    { return p.getLeft()*10000 + p.getRight()*100; }
  };
}
struct ltPair: public binary_function<const Pair, const Pair, bool>
  {
  bool operator()(const Pair p1, const Pair p2) const
    { return p1 < p2; }
  };
typedef set<Pair> pset;                          //A set of pairs.
ostream& operator<<(ostream& output, const pset &ps);
typedef __gnu_cxx::hash_set< const Pair, __gnu_cxx::hash<Pair> > phset;



#endif
