/* Krister Swenson                                                 Summer 2006

This is a set that can contain anything that has the '==' operator along with a 'size()' function.
It acts like a set should.
*/
#ifndef SET
#define SET

#include <ext/hash_set>


  //Comparison function for a hash_set on a T.
template <class S>
struct eqfunc
  {
  bool operator()(const S v1, const S v2) const
    { return (v1 == v2); }
  };


template <class T>
class Set
  {
  //friend std::ostream& operator<<(std::ostream& output, const T& it);

  public:
    Set(); 
    ~Set() { }
     //Add a copy of the given thing to the set.
    void add(const T it);

  private:
    __gnu_cxx::hash_set<const T, __gnu_cxx::hash<const T>, eqfunc> theset;
  };




/*Add a copy of the given thing to the set.
*/
template <class T>
void Set<T>::add(const T it)
  {
  theset.insert(it);
  }


/*
ostream& operator<<(ostream& output, const T& it)
  {
  hash_set<const T, std::hash<const T>, eqfunc>::iterator i;
  output << "{";
  if(it.size())
    {
    i = it.begin();
    output << it[i++];
    while(i!=it.end())
      output << "," << it[i++] << endl;
    }
  output << "}";

  return output;
  }
*/


#endif
