//Krister Swenson, Mark Marron                               Spring 2003
//
// Provides the interface to the multi code.
//

#ifndef MULTIMED_H
#define MULTIMED_H

#ifdef _MSC_VER
#pragma warning (disable : 4503) // Turn off dumb Visual C++ warning
#endif

#include <ext/slist>
#include <ext/hash_map>
#include <vector>
#include <limits>
#include <iterator>
#include "SortSeq.h"	// globalSortSequence
#include "renamemulti.h"
#include "../graph/med.h"

using namespace std;

// #define MABROUK         //Define this if you want copies to be disregarded.




  //Return an approximate Minimum Edit Distance from -s1- to -s2- under 
  //insertions, deletions, copies, and inversions.
int multiMED(int* s1, int ls1, int* s2, int ls2);
int multiMED(int* s1, int ls1, int* s2, int ls2, int &inv, int &del, int &ins);




  //Same as multiMED, but make doubly sure not to calculate a sorting sequence
int multiMED_noSort(int* s1, int ls1, int* s2, int ls2);
int multiMED_noSort(int* s1, int ls1, int* s2, int ls2, int &inv, int &del,
		    int &ins);


  //Output a sequence.
void output(const char* title, int* seq, int len);

#endif //MULTIMED_H
