/* Krister Swenson                                                  Winter 2010

Print a list of all the first words corresponding to maximal independent sets
of noninterfering inversions (for the given permutation).
*/

#include <iostream>
#include <vector>
#include "../graph/med.h"
#include "../graph/Pair.h"
#include "../seqtools/seqfuncs.h"
#include "../tools/tools.h"

using namespace std; 


#define ONLY_SAFE 0



int main()
  {
  int *s1=0;
  cerr << "seq:";
  int s1len = getInputSeq(&s1);

  Ograph g(s1, s1len);   //Build the graph for s1.
                         //All maximal sets of first words of a normal form.
                         // (for the traces corresponding to sorting paths)
  if(ONLY_SAFE)
    {
    cout << "All Maximal Safe First words:\n";
    g.printMalWords(cout);
    }
  else
    {
    cout << "All Maximal First words:\n";
    g.printMalWords(cout, false);
    }

  free(s1);
  return(0);
  }
