/* Krister Swenson                                                  Spring 2006

Find a set of maximum noninterfering inversions.
Take a single input.
*/

#include <iostream>
#include <vector>
#include "../graph/med.h"
#include "../graph/Pair.h"
#include "../seqtools/seqfuncs.h"
#include "../tools/tools.h"

using namespace std; 




int main()
  {
  int *s1=0;
  cout << "seq:";
  int s1len = getInputSeq(&s1);

  Ograph g(s1, s1len);           //Build the graph for s1.

    //Find a maximum independant set of commuting inversions.
  cout << "commuting MIS: " << g.getCommutingMIS() << endl;
    //Find a maximum independant set of noninterfering inversions.
  list<Pair> nmis = g.getNonintMIS();
  cout << "noninterfering MIS: " << nmis << endl;
  cout << nmis.size() << "/" << g.getDistNH() << " sorted.\n";
  assert(g.isNonint(nmis));

  free(s1);
  return(0);
  }
