/* Krister Swenson                                                  Summer 2008

For a random permutation, print the average distance for all possible signings
and the distance of the most sorted signing.
*/

#include "../tools/tools.h"
#include "../seqtools/seqfuncs.h"
#include "../graph/Ograph.h"
#include <vector>
#include <algorithm>

#define SIZE 12
#define REPS 40

using namespace std; 


void trySignings(vector<int> &distlist, vector<int> &p, int i);

int main()
  {
  vector<float> means;
  cout << "size:" << SIZE << " reps:" << REPS << endl;
  for(int i=0; i<REPS; i++)
    {
    vector<int> distlist;
    vector<int> p = getRandPerm(SIZE);
    trySignings(distlist, p,0);
    cout << "-" << endl;
    means.push_back(getMean(distlist));
    cout << "average distance:" << means.back() << endl;
    cout << "standard deviation:" << getStandardDev(distlist) << endl;
    cout << "min distance:" << *min_element(distlist.begin(), distlist.end())
         << endl;
    }

  cout << "-SUMMARY- mean:" << getMean(means) << endl;

  return(0);
  }


/*Try all possible signings of elements at i or greater.
*/
void trySignings(vector<int> &distlist, vector<int> &p, int i)
  {
  if((int)p.size() == i)
    {
    Ograph g(p);
    distlist.push_back(g.getDist());
    return;
    }

  trySignings(distlist, p, i+1);  //Recurse with it positive.
  p[i] *= -1;                     //Make it negative.
  trySignings(distlist, p, i+1);  //Recurse with it negative.
  p[i] *= -1;                     //Make it positive again.
  }
