/* Krister Swenson                                                  Spring 2006

Print the size of the largest signature between the two given sequences
(with the identity as the implicit third).
*/

#include "sigfuncs.h"
#include "../seqtools/seqfuncs.h"

using namespace std; 


#define GREEDY 0  //Use the greedy (inexact) method if one of the following:
                  // (1) Single Push upward (arbitrary tie-breaker).
                  // (2) No tie-breaker but upward truncation based on beenseen.
                  // (3) No tie-breaker and no upward trucation.



int main()
  {
  int *s1=0, *s2=0;
  int s1len = getInputSeq(&s1);
  int s2len = getInputSeq(&s2);

  assert(s1len == s2len);

  Ograph g1(s1, s1len);      //Build the graph for s1.
  Ograph g2(s2, s2len);      //Build the graph for s2.

  Ograph id(makeID(s2len), s2len); //Build the identity graph.

  int maxdepth=0;
  if(GREEDY == 1)
    {
    cerr << "SP:";
    maxdepth = getGreedySigSP(g1, g2, id);
    }
  else if(GREEDY == 2)
    maxdepth = getGreedySigF(g1, g2, id);
  else if(GREEDY == 3)
    maxdepth = getGreedySig(g1, g2, id);
  else
    maxdepth = getSigSize(g1, g2, id);

  cout << maxdepth << endl;

  free(s1);
  free(s2);
  return(0);
  }
