/* Krister Swenson                                                  Spring 2006

Generate all signature inversions from the identity up.
  `-> run "siglattice > graph.dot" and then
      "drawlattice" or "dot -Tps graph.dot -o graph.ps"

Or print just the paths of least resistance(greedily maximize the number of
common safe reversals between the two) if the 'GREEDY' directive is non-zero.

If DEADEND is set then...
generate all sequences from two starting sequences (as if they were a deadend
and we are moving downward in the lattice from them) that always move away from
both and produce no paths that could continue upwards.
   `--> don't remember how well this works.
*/

#include "sigfuncs.h"

using namespace std; 


#define DEADEND 0    //Go downward as though s1 and s2 are a dead-end.
#define GREEDY 0     //Print the greedy paths instead of the whole lattice.



int main()
  {
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//OTHERS:
  //int s1[] = {3,-1,2};       //(h)
  //int s1[] = {-3,-1,2};      //(7)
  //int s2[] = {-3,-1,-2};     //(1a)
  //int s2[] = {-3,2,1};       //(a1)

  //int s1[] = {-1,2,5,-3,4};
  //int s2[] = {-1,2,5,-3,4};

  //int s1[] = {4,-2,6,-3,1,-5,7};
  //int s2[] = {-2,6,-4,-3,-7,-1,-5};

  //int s1[] = {3,1,5,2,4,7,9,11,13,-6,-8,-10,-12}; //shamir.benign.ext
  //int s2[] = {3,1,5,2,4,7,-11,-9,13,-6,-8,-10,-12};
  //int s1[] = {3,1,5,2,4,7,-13,-11,-9,-6,-8,12,10};//shamir.benign.ext.oneup
  //int s2[] = {3,1,5,2,4,7,11,13,-9,-6,-8,12,10};
  //int s1[] = {2,4,1,5,3,-10,6,-11,7,-12,8,-13,9}; //shamir.benign.ext.renamed
  //int s2[] = {2,4,1,5,3,-10,6,-11,-8,-12,-7,-13,9};
  //int s1[] = {3,2,1,-8,4,-9,5,-10,6,-11,7}; //shamir.b.ext2.renamed
  //int s2[] = {3,2,1,-8,4,-9,-6,-10,-5,-11,7};
  //int s1[] = {-5,1,-6,2,-7,3,-8,4};    //shamir.b.renamed
  //int s2[] = {-5,1,-6,-3,7,-2,-8,4};
  //int s1[] = {-4,1,-5,2,-6,3};         //shamir.b.renamed.6
  //int s2[] = {-4,1,6,2,-5,3};
  //int s1[] = {4,1,2,-5,3};         //shamir.b.renamed.6
  //int s2[] = {-2,3,4,-5,-1};
  //int s2[] = {-4,-2,-5,-1,-6,3};
  int s1[] = {12,-7,-6,-5,-4,-3,-2,-1,-11,-10,-9,-8,13,26,22,-32,-31,-30,-29,-28,-27,-21,-20,-19,-25,15,24,-14,-18,-17,-16,-23,33,34,35};
  int s2[] = {12,-26,-13,24,-14,-34,-33,11,-30,-29,-28,-27,-21,-20,-19,-16,-23,7,22,-18,-17,-25,15,8,9,10,-6,-5,-4,-3,-2,-1,31,32,35};

//POSTER:
  //int s1[] = {1,2,-9,-8,-6,-5,7,3,4,-12,-11,-10,13,-16,-15,-14,17,18,19};//0
  //int s2[] = {1,2,3,-5,-4,6,8,9,-7,-12,-11,-10,13,14,15,16,17,18,19};//1
  //int s1[] = {1,2,3,-11,-4,7,-12,-5,-10,-6,-19,-17,-15,-8,13,14,9,18,-16};//2
  //int s2[] = {1,2,19,6,10,5,12,-7,4,11,-3,-17,-15,-8,13,14,9,18,-16};//2.e
  //int s2[] = {1,2,-10,-6,4,11,-3,5,12,-7,-9,-8,13,14,-18,-17,19,16,15};//3
  //int s2[] = {1,2,-10,-6,4,11,-3,5,12,8,9,7,13,14,-18,-17,19,16,15};//3.e
  //int s1[] = {5,6,7,-1,-4,-3,10,11,-12,-2,8,9,13,-15,14,16,17,19,18};//4
  //int s2[] = {5,6,7,-1,-4,-3,-2,-11,-10,-9,-8,12,-18,-19,-17,-16,-15,-14,-13};//5

//CANONICAL:
  //int s1[] = {2,4,6,8,-1,-3,-5,-7,9};      //Shamir
  //int s2[] = {2,-6,-4,8,-1,-3,-5,-7,9};    //Shamir Benign
  //int s2[] = {2,4,-6,8,-1,-3,-5,-7,9};     //Shamir B1
  //int s2[] = {-6,-4,-2,8,-1,-3,-5,-7,9};   //Shamir B2
  //int s2[] = {2,4,6,8,-1,7,5,3,9};         //Shamir B3
  //int s2[] = {-2,4,6,8,7,5,3,1,9};         //Shamir B4
  //int s1[] = {-1,-2,-3,-4,-5,-6};          //Caterpillar
  //int s2[] = {-1,3,2,-4,-5,-6};            //Caterpillar Benign
  //int s2[] = {5,4,3,2,1,-6};               //Caterpillar Benign2
  //int s1[] = {-5,7,-3,9,-1,6,-4,8,-2};     //Single Catalyst
  //int s2[] = {-5,7,-3,9,2,-8,4,-6,1};      //Single Catalyst Benign
  //int s1[] = {-4,-6,3,7,2,-5,1};           //Tannier
  //int s2[] = {-4,-6,-2,-7,-3,-5,1};        //Tannier Benign
  //int s2[] = {5,-2,-7,-3,6,4,1};           //Tannier Benign2

  //int s1[] = {1,2,3,4,5,6,13,14,15,-10,-9,-8,-7,-12,-11,-49,-48,-47,-46,-45,-44,-43,-42,-41,-40,-39,-38,-37,-36,-35,34,-21,-20,-19,-18,-17,-16,50,51,52,53,54,55,56,57,31,32,33,22,23,-64,-63,62,-61,-60,-59,-58,-30,-29,-28,-27,-26,-25,-76,-75,-74,-73,-72,-71,-70,-69,-68,-67,-66,-65,24,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,-114,-113,-112,-111,-110,-109,-108,-107,-106,-105,-104,-103,-102,-101,-100,-99,-98,-97,-96,-95,-125,-124,-123,-122,-121,-120,-119,-171,-170,-159,-158,-157,-156,-155,-154,-153,169,160,161,162,163,164,-167,-166,-165,168,-152,-151,-150,-149,-148,-147,-146,-145,-144,134,135,136,-116,-115,137,138,139,140,141,142,143,-193,-182,-181,-180,189,190,-185,-184,-183,-192,-191,186,187,188,-179,196,-176,-175,-174,-173,-172,-118,-117,126,127,128,129,130,131,132,133,194,195,-178,-199,-198,-197,177};
  //int s2[] = {1,2,3,4,5,47,48,49,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-46,42,43,21,34,35,36,-37,38,39,40,41,-45,-44,-20,-19,-18,-17,-16,-59,-62,63,64,-23,-22,60,90,91,29,30,58,-61,-70,-69,82,83,84,105,106,107,86,87,-88,89,-52,-51,-50,-33,-32,-31,-57,-56,-55,-94,-93,-92,-28,-27,-26,-25,-76,-75,-74,103,104,85,108,109,68,-73,-72,-71,53,54,-114,-113,-112,124,125,95,96,77,78,79,80,81,-102,-101,142,143,-148,-147,159,170,171,119,-24,65,66,67,110,111,-123,-122,-121,-120,97,98,-155,-154,-153,-130,197,198,133,-139,-145,-144,141,-100,-99,-166,-165,168,-152,-151,-150,-175,-174,-173,-172,-136,-135,-134,-140,149,176,-196,137,-187,-186,-146,138,188,-179,115,116,-118,-117,126,127,128,129,177,-158,-157,-156,167,-164,-163,-162,-161,-160,-169,131,132,199,178,-195,184,185,-183,-192,-191,-190,-189,180,181,182,193,194};

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%% DEAD-ENDS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  //int s1[] = {2,3,-1,4,5,6,7};
  //int s2[] = {1,2,3,4,-6,7,-5};
  int dids[] = {-2,-5,-4,-3,1,6,7};

//GENERAL:
  //int s1[] = {-4,-1,5,6,8,-3,7,-2,9};      //Shamir Benign (3)
  //int s2[] = {-4,-1,5,6,8,2,7,3,9};
  //int dids[] = {-8,-2,-1,-3,-7,-6,-5,-4,9};
  //int s1[] = {-5,-4,-1,6,8,-3,7,-2,9};      //Shamir Benign (4)
  //int s2[] = {-5,-4,-1,6,8,2,7,3,9};
  //int dids[] = {1,-8,-2,-3,-7,-6,-5,-4,9};
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 

  int s1len = sizeof(s1)/sizeof(int);       //The 1st sequence length.
  int s2len = sizeof(s2)/sizeof(int);       //The 2nd sequence length.
  assert(s1len == s2len);

        //DEADEND stuff:
  int didslen = sizeof(dids)/sizeof(int);
  if(DEADEND)
    {
    invertSeq(s1, s1len);         //Must invert because of joel.
    invertSeq(s2, s2len);         //Must invert because of joel.
    invertSeq(dids, didslen);     //Must invert because of joel.
    assert(s1len == didslen);
    }

/*
  int is1[s1len];
  copy(&s1[0], &s1[s1len], &is1[0]);
  int is1len = s1len;
  invertSeq(is1, is1len);
  int is2[s2len];
  copy(&s2[0], &s2[s1len], &is2[0]);
  int is2len = s2len;
  invertSeq(is2, is2len);
*/ 
  cerr << "S1:\t";
  printSeq(s1, s1len);
  cerr << "\nS2:\t";
  printSeq(s2, s2len);

  Ograph g1(s1, s1len, true);     //Build the (inverse) graph that sorts to s1.
  Ograph g2(s2, s2len, true);     //Build the (inverse) graph that sorts to s2.

  Ograph did(dids, didslen, true);//Build a graph labeled according to the sid.
  Ograph id(makeID(s2len), s2len);//Build the identity graph.


  cerr << "\nS1 INV:\t" << g1.getSeqString();
  cerr << "\nS2 INV:\t" << g2.getSeqString() << endl;


  cout << "digraph SignatureLattice"
       << "\n  {\n  "
       << "size = \"10,8\";"
       << "orientation=landscape;"
       << "center=true;"
       << "concentrate=true;"
       << "ranksep=.5;"
       << endl;
  if(DEADEND)
    printDeadend(g1, g2, did, 1);
  else if(GREEDY)
    {
    int maxdepth = printGreedy(g1, g2, id, 0);
    cerr << "MAXDEPTH: " << maxdepth << endl;
    }
  else
    printSigLattice(g1, g2, id, -1);
  cout << "  }" << endl;

  return(0);
  }
