/* Krister Swenson                                                 Winter 2007-8

A random assortement of functions.
*/
#ifndef TOOLS_H
#define TOOLS_H

#include <iostream>
#include <sstream>
#include <math.h>
#include <vector>
#include <set>
#include <list>
#include <ext/hash_set>
#include <algorithm>
#include <utility>
#include <numeric>
#include <string>


using namespace std;
using namespace __gnu_cxx;


typedef std::pair<int,int> ipair;                   //A pair of integers.

  //Return the mean of the given vector.
float getMean(const vector<int> &v);
float getMean(const vector<float> &v);

  //Return the standard deviation of the values in the given vector.
float getStandardDev(const vector<int> &v);
float getStandardDev(const vector<float> &v);

  //Return n!
long long factorial(int n);
  //Computes n choose k.  From wikipedia.
unsigned long long choose(int n, int k);

  //Take a list and return a set with the same elements.
set<int> listTOset(const list<int> &l);

  //Return a string for the given set.
  //  ({2.3.4} becomes {2.-.3})
string getInvSetStr(const set<int> &theset);



/*TEMPLATES FOR OUTPUT OF STL OBJECTS*/

/* Print a vector.
*/
template<typename T>
ostream& operator<<(ostream& output, const vector<T> &v)
  {
  for(int i=0; size_t(i)<v.size(); i++)
    output << v[i] << " ";
  return output;
  }
/* Print a ipair.
*/
//ostream& operator<<(ostream& output, const ipair &p)
  //{ output << "[" << p.first << "," << p.second << "]"; return output; }
/* Print a list.
*/
template<typename T>
ostream& operator<<(ostream& output, const list<T> &l)
  {
  copy(l.begin(), l.end(), ostream_iterator<T>(output, " "));
  return output;
  }
/* Print a hash_set.
*/
template<typename T>
ostream& operator<<(ostream& output, const hash_set<T> &l)
  {
  copy(l.begin(), l.end(), ostream_iterator<T>(output, " "));
  return output;
  }
/* Print a set.
*/
template<typename T>
ostream& operator<<(ostream& output, const set<T> &l)
  {
  copy(l.begin(), l.end(), ostream_iterator<T>(output, " "));
  return output;
  }
/* Print a pair.
*/
template<typename T, typename R>
ostream& operator<<(ostream& output, const pair<T, R> &p)
  {
  output << "[" << p.first << " " << p.second << "]";
  return output;
  }
/* Print a list of sets of ints.
ostream& operator<<(ostream& output, const list< set<int> > &l)
  {
  for(list< set<int> >::const_iterator i=l.begin(); i!=l.end(); i++)
    output << *i << ",";

  return output;
  }
*/



#endif
